
// ------------------------------------------------------------
// -------------------- the class -----------------------------
// ------------------------------------------------------------
Orbita [] orbitas;

// ------------------------------------------------------------
// ----------------- Data Class construction ------------------
void iniciarDataViz() {

  // 1. We first figure out how many orbits to create
  cantidad = totalCols;

  //2. Temporary Array
  Orbita [] orbitasT = new Orbita[cantidad];
  // 3. We fill the values
  //for (int i = 1; i < cantidad; i++) {
  for (int i = 1; i < cantidad; i++) {
    int b = cantidad-i;
    b = i;
    // a. We establish the orbit
    float tamanoOrbita = map(b, 0, cantidad, orbitaMin, orbitaMax);

    // b. We create the object
    orbitasT[b] = new Orbita( tamanoOrbita, i );
  }

  //4. We equal the values
  orbitas = orbitasT;
}
// ------------------------------------------------------------
// ----------------- Showing the class ------------------
void mostrarDataViz() {
  pushMatrix();
  translate(centroX, centroY);

  for (int i = 1; i < orbitas.length; i++) {
    orbitas[i].mostrar();
  }

  popMatrix();
}

// -------------------------------------------------------------------------------------------
// ----------------------------- ORBITA CLASS ------------------------------------------------
// -------------------------------------------------------------------------------------------

class Orbita {

  // Propiedades **********************************************************
  float orbita; // posicion de ancho
  String titulo; // El title de la orbita
  int pos; // The position (so we calculate title related things)
  float grosor, suma; 
  float animArco, velArco;
  float velArcoMin = 0.0031; // 0.0031 original
  float velArcoMax = 0.021; // 0.01 original
  float anguloTitlesGlobal;
  int sentido;
  // *
  // Data to every inhabitant
  int cantidadPobladoresBoston, cantidadPobladoresOsama;
  float [] pobladoresAnguloBostonO;
  float [] pobladoresAnguloBostonA;
  float [] pobladoresAnguloBostonD;
  float [] pobladoresRuidoBoston;
  float [] pobladoresVarBoston;
  float [] pobladoresAnguloOsamaO;
  float [] pobladoresAnguloOsamaA;
  float [] pobladoresAnguloOsamaD;
  float [] pobladoresRuidoOsama;
  float [] pobladoresVarOsama;

  Boolean [] letrasPrendidas; // To animate the titles
  int cantidadLetras = 30;
  // Constructores ********************************************************
  Orbita(float orbita, int pos) {
    this.orbita = orbita;
    this.pos = pos;
    this.titulo = headers[pos].toUpperCase();

    for (int i = 1; i < totalRows; i++ ) {
      this.suma = boston[i][pos];
    }
    this.grosor = suma;
    this.velArco = random(velArcoMin, velArcoMax);
    this.animArco = 0;
    this.anguloTitlesGlobal = random(360);
    this.sentido = 1;
    if (random(2) > 1) sentido = -1;
    this.letrasPrendidas = new Boolean [cantidadLetras]; // For the titles
    for (int i = 0; i<cantidadLetras; i++) {
      letrasPrendidas[i] = false;
    }
    // We find out how many inhabitants we have
    this.cantidadPobladoresBoston = cantidadPobladores( boston, this.pos);
    this.cantidadPobladoresOsama = cantidadPobladores( osama, this.pos );
    // Only if we have more than 0, we add
    if (cantidadPobladoresBoston > 0) {
      //We start the Arrays
      pobladoresAnguloBostonO = new float[cantidadPobladoresBoston];
      pobladoresAnguloBostonA = new float[cantidadPobladoresBoston];
      pobladoresAnguloBostonD = new float[cantidadPobladoresBoston];
      pobladoresRuidoBoston = new float[cantidadPobladoresBoston];
      pobladoresVarBoston = new float[cantidadPobladoresBoston];

      // We create a local counter
      int contadorLocal = 0;
      // Boston
      for (int i = 1; i < totalRows; i++) {
        // How many inhabitants for this day???
        int cuantosHay = boston[i][this.pos];
        // We fill the arrays
        for (int j = 0; j < cuantosHay; j++) {
          // So they don't appear cenetered in the screen
          float alteracion = random(toleranciaAnguloPoblador);
          if (random(2)>1) alteracion *= -1;
          pobladoresAnguloBostonO[contadorLocal] = map( i, 0, totalRows, anguloInicio, anguloFinal )+alteracion;
          pobladoresAnguloBostonA[contadorLocal] = (anguloFinal-abs(anguloInicio))/2;
          pobladoresAnguloBostonD[contadorLocal] = pobladoresAnguloBostonO[contadorLocal];
          pobladoresRuidoBoston[contadorLocal] = random(ruidoPobladoresMin, ruidoPobladoresMax);
          pobladoresVarBoston[contadorLocal] = 0;
          contadorLocal++;
        }
      }
    }
    if (cantidadPobladoresOsama > 0) {
      //We start the Arrays
      pobladoresAnguloOsamaO = new float[cantidadPobladoresOsama];
      pobladoresAnguloOsamaA = new float[cantidadPobladoresOsama];
      pobladoresAnguloOsamaD = new float[cantidadPobladoresOsama];
      pobladoresRuidoOsama = new float[cantidadPobladoresOsama];
      pobladoresVarOsama = new float[cantidadPobladoresOsama];
      // Osama
      int contadorLocalB = 0;
      for (int i = 1; i < totalRows; i++) {
        // How many inhabitants for this day???
        int cuantosHay = osama[i][this.pos];
        // We fill the arrays
        for (int j = 0; j < cuantosHay; j++) {
          // So they don't appear cenetered in the screen
          float alteracion = random(toleranciaAnguloPoblador);
          if (random(2)>1) alteracion *= -1;
          pobladoresAnguloOsamaO[contadorLocalB] = map( i, 0, totalRows, anguloInicio, anguloFinal )+alteracion;
          pobladoresAnguloOsamaA[contadorLocalB] = (anguloFinal-abs(anguloInicio))/2;
          pobladoresAnguloOsamaD[contadorLocalB] = pobladoresAnguloOsamaO[contadorLocalB];
          pobladoresRuidoOsama[contadorLocalB] = random(ruidoPobladoresMin, ruidoPobladoresMax);
          pobladoresVarOsama[contadorLocalB] = 0;
          contadorLocalB++;
        }
      }
    }
  }

  // Funciones de inicio
  int cantidadPobladores( int[][]datos, int columna ) {
    // We create a local counter
    int cantidadLocal = 0;
    for (int i = 1; i < totalRows; i++) {
      // println("Verificando columna: "+columna+" Row: "+i+" Title: "+titulo);
      cantidadLocal += datos[i][columna];
    }
    return cantidadLocal;
  }
  // Getters/Setters *****************************************************
  float getOrbita() {
    return this.orbita;
  }


  //Métodos **************************************************************
  // ------------------------------
  void mostrar() {
    orbitaPrueba(); // Just to see the orbits...
    arcos();
    if (millis()/1000 > segundosTitlesAppearance) orbitTitle();
    // We show each item
    if (pobladoresBoston) pobladoresBoston(); // 
    if (pobladoresOsama) pobladoresOsama(); //
  }
  // ------------------------------
  void orbitaPrueba() {
    noFill();
    stroke(0, 0, 0, 84*anim/4);
    strokeWeight(0.4);
    ellipse(0, 0, orbita, orbita);
  }
  // ------------------------------
  void arcos() { // To create the lines of each topic
    // Drawing time
    pushMatrix();
    rotate(radians(anguloInicio));
    stroke(0, 0, 0, 180);
    strokeCap(SQUARE);
    strokeWeight(suma/3);
    noFill();
    arc(0, 0, orbita, orbita, radians(0), radians(anguloFinal+45)*animArco);
    popMatrix();

    // Animation calculation
    animArco += velArco;
    if (animArco >= 1) animArco = 1;
  }
  // ------------------------------
  // -- It is a dirty job, but someone's gotta do it!!!
  // We will try to put radially the titles
  void orbitTitle() {
    //Angle degrees between each letter
    float intervaloAngulo = 2.7;
    intervaloAngulo = map(orbita, orbitaMin, orbitaMax, 9, 1.6);

    // Size of the title
    float tamanoTitle = titulo.length();

    // The starting angle
    float startingAngle = 0;
    startingAngle = -( intervaloAngulo*(tamanoTitle/2) );

    // We iterate through each word
    for (int i = 0; i < tamanoTitle; i++) {

      // Translating and rotating operations
      pushMatrix();
      translate(2, 1);
      rotate(radians(-90)); // So we start at the Y axis
      rotate(radians(startingAngle+( intervaloAngulo*i ))); // The actual letter angle
      if (titlesAzar) rotate(radians(anguloTitlesGlobal));
      /*
      if(pos%2 == 0 ){
       rotate(radians(-45));
       }else{
       rotate(radians(45));
       }
       */
      // WE draw the letter
      fill( 0, 0, 0, 210 );
      noStroke();
      textFont(roundTitlesAlias, 8);
      //roundTitlesAlias
      textAlign(CENTER);

      char letraActual = titulo.charAt(i);
      if (letraActual == '_')letraActual = ' ';
      if (letraActual == 'I')letraActual = 'l';
      pushMatrix();
      translate(orbita/2, 0);
      rotate(radians(90));
      if (letrasPrendidas[i]) text(letraActual, 0, 0);
      popMatrix();

      // Rotation of global angle
      //anguloTitlesGlobal += 0.02*sentido;
      popMatrix();

      //Animation check of the title
      if (!letrasPrendidas[i] && random(100) > 91.1) letrasPrendidas[i] = true;
    }
  }
  // ------------------------------
  void pobladoresBoston() {
    for (int i = 0; i<cantidadPobladoresBoston; i++) {

      // A. Calculate any position if there is something to calculate
      float dif = calcularDiferencia(pobladoresAnguloBostonA[i], pobladoresAnguloBostonO[i], friccionPobladores);
      if (abs(dif) > 0.1) pobladoresAnguloBostonA[i] += dif;

      // B. WE calculate the noise
      pobladoresVarBoston[i] += pobladoresRuidoBoston[i];
      float miniDiferencia = noise(pobladoresVarBoston[i]);
      miniDiferencia = map(miniDiferencia, 0, 1, -15, 15);
      if (!pobladores) miniDiferencia = 0;

      // C. We show the  settler
      pushMatrix();
      rotate(radians( pobladoresAnguloBostonA[i]+miniDiferencia));
      fill(0);
      fill(255, 0, 0);
      noStroke();
      stroke(255, 0, 0);
      strokeWeight(random(1));
      ellipse(orbita/2, 0, 3, 3);
      popMatrix();
    }
  }

  // ------------------------------

  void pobladoresOsama() {

    for (int i = 0; i<cantidadPobladoresOsama; i++) {
      // A. Calculate any position if there is something to calculate
      float dif = calcularDiferencia(pobladoresAnguloOsamaA[i], pobladoresAnguloOsamaO[i], friccionPobladores);
      if (abs(dif) > 0.1) pobladoresAnguloOsamaA[i] += dif;

      // B. WE calculate the noise
      pobladoresVarOsama[i] += pobladoresRuidoOsama[i];
      float miniDiferencia = noise(pobladoresVarOsama[i]);
      miniDiferencia = map(miniDiferencia, 0, 1, -15, 15);
      if (!pobladores) miniDiferencia = 0;

      // C. We show the  settler

      pushMatrix();
      rotate(radians( pobladoresAnguloOsamaA[i]+ miniDiferencia) );
      translate(3, 0);
      fill(0);
      fill(255, 0, 0);
      fill(82, 190, 255); // Azul
      fill(210, 214, 199); // Crema
      fill(0);
      stroke(0, 0, 0);
      strokeWeight(random(1));
      ellipse(orbita/2, 0, 2, 2);
      popMatrix();
    }
  }

  // ------------------------------
  // This funcion calculates the difference between two values
  //                        (   inicio,    deseo   )
  float  calcularDiferencia( float v1, float v2, float friccion ) {
    // We determine the interval, the difference
    float intervalo = 0;
    if (v1 > v2) intervalo = v1-v2;
    if (v2 > v1) intervalo = v2-v1;
    // Applying some friction
    intervalo /= friccion;
    // Everything absolute (no surprises please)
    intervalo = abs(intervalo);

    if (v2 < v1 ) intervalo *= -1;

    return intervalo;
  }
  // ------------------------------

  // Class ends with next } >>>>>
}
