// ------------------------------------------------------------
// -------------------- S P E A K  --------------------------------
// ----------------------------------------------------------------
// This function will make the code talk -----
// ----------------------------------------------------------------

// 
float velocidadSpeak = 0.7; // 0.8 original
float alphaDer, alphaIzq; // Para controlar la animeishon
float anguloDer = anguloInicio; // El giro
float anguloIzq = anguloInicio; 
float diferenciaDer, diferenciaIzq; // As'i controlamos los cambios
float diferenciaDerMax = 100; // En angulos
float diferenciaIzqMax = 100; // En angulos
int currentTopic = 1;
// No olvidar esta variable iteracionTitlesOsama[currentTopic] que la declaramos previamente
String currentTitleDer = "meh";
String currentTitleIzq= "meh";

// ------------------------------------------------------------------------------------

void speak() {
  // We check if it is the first time
  if (primeraVezTitles) {
    changeBookTitle("der");
    changeBookTitle("izq");
    mixItUp();
    primeraVezTitles = false;
  }

  // We show the current RING per topic
  float orbit = orbitas[currentTopic].getOrbita();
  stroke(255, 0, 0, 100);
  strokeWeight(9);
  noFill();
  ellipse(centroX, centroY, orbit, orbit);

  // Mostramos el derecho
  if (millis()/1000 > segundosSpeakAppearanceDer) speakTitleDer();

  // Mostramos el izquierdo
  if (millis()/1000 > segundosSpeakAppearanceIzq) speakTitleIzq();
}
// ------------------------------------------------------------------------------------
//  This duplcation functions is a very dumb way to do it, I know
// But I thought at the beginning they were gonna be totally different.
void cambiarDer() {
  anguloDer = anguloInicio; // We establish a new angle
  diferenciaDer = 0; // Difference is zero

  // CHANGING CATEGORY / TITLE
  if ( automatizado ) changeTopic(1); // We will change the whole dewey Category
  changeBookTitle("der");

  // HERE IS WHERE THE SPEAK FUNCTION SHOULD GO !!!!!
  //if (voz) tts.speak(currentTitleDer);
  if (voz) fijarTitulo(currentTitleDer);
  if (voz) hablar(currentTitleDer);
}
void speakTitleDer() {

  // Calculamos el angulo (se va a sumar)
  anguloDer += velocidadSpeak;

  // We calculate the alpha
  alphaDer = map( diferenciaDer, 0, diferenciaDerMax, 255, 0 );

  // Procedemos a colocar lo visual
  pushMatrix();
  translate(centroX, centroY); // Translation operations
  rotate(radians(anguloDer));
  strokeWeight(random(0.6, 0.8));
  stroke( 0, 0, 0, alphaDer );
  line(orbitaMax/2, 0, orbitaMax/2 +30, 0);
  fill(0, 0, 0, alphaDer);
  ellipse(orbitaMax/2, 0, 3, 3);
  line(orbitaMax/2 +30, 0, orbitaMax/2 +30, -4);
  line(orbitaMax/2 +30, 0, orbitaMax/2 +30, +4);

  // Texto
  fill(0, 0, 0, alphaDer);
  textFont(speakFont, 10);
  textAlign(LEFT);
  text( currentTitleDer, orbitaMax/2 +39, 2  );

  popMatrix();

  // Calculamos si tenemos que acabar y cambiar el title
  diferenciaDer += velocidadSpeak;
  if (diferenciaDer > diferenciaDerMax) cambiarDer();
}
// ------------------------------------------------------------------------------------
void cambiarIzq() {
  anguloIzq = anguloInicio; // We establish a new angle
  diferenciaIzq = 0; // Difference is zero

  // CHANGING CATEGORY / TITLE
  if ( automatizado ) changeTopic(1); // We will change the whole dewey Category
  changeBookTitle("izq");

  // HERE IS WHERE THE SPEAK FUNCTION SHOULD GO !!!!!
  //if (voz) tts.speak(currentTitleIzq);
  if (voz) fijarTitulo(currentTitleIzq);
  if (voz) hablar(currentTitleIzq);
}
void speakTitleIzq() {

  // Calculamos el angulo (se va a restar)
  anguloIzq += velocidadSpeak;

  // We calculate the alpha
  alphaIzq = map( diferenciaIzq, 0, diferenciaIzqMax, 255, 0 );

  // Procedemos a colocar lo visual
  pushMatrix();
  translate(centroX, centroY); // Translation operations
  rotate(radians(anguloIzq));
  strokeWeight(random(0.6, 0.8));
  stroke( 0, 0, 0, alphaIzq );
  line(orbitaMax/2, 0, orbitaMax/2 +30, 0);
  fill(0, 0, 0, alphaIzq);
  ellipse(orbitaMax/2, 0, 3, 3);
  line(orbitaMax/2 +30, 0, orbitaMax/2 +30, -4);
  line(orbitaMax/2 +30, 0, orbitaMax/2 +30, +4);

  // Texto
  fill(0, 0, 0, alphaIzq);
  textFont(speakFont, 10);
  textAlign(LEFT);
  text( currentTitleIzq, orbitaMax/2 +39, 2  );

  popMatrix();

  // Calculamos si tenemos que acabar y cambiar el title
  diferenciaIzq += velocidadSpeak;
  if (diferenciaIzq > diferenciaIzqMax) cambiarIzq();
}
// -----------------------------------------------------------------------
// ------------------------------------------------------------------------


void changeTopic(int direccion) {
  // We will change of topic only if it is not the last one (this interaction type needs further revision)
  if (direccion == 1) {
    if (currentTopic < totalCols-1) {
      currentTopic++;
    } else {
      currentTopic = 1;
    }
  } else if (direccion == 2) {
     if (currentTopic > 2) {
      currentTopic -= 1;
    } else {
      currentTopic = totalCols-1;
    }
  }

  // We check if the topic has any books
  if ( titlesTotalesOsama[currentTopic] < 2 ) {
    println( ">> TTL >> We tried to change to: "+currentTopic+" but no titles there ( "+titlesTotalesOsama[currentTopic]+" )");
    changeTopic(1);
  } else {
    println( ">> TTL >> Changing title to: "+currentTopic+" with totals: "+titlesTotalesOsama[currentTopic]+" current: "+iteracionTitlesOsama[currentTopic]);
  }
}
// ---------------------------------------------------
// We will just change the book title
//                 (    "der" or "izq"   )
void changeBookTitle(String tipo) {  
  // We will change the title only if it is not the last one ||||||
  if ( iteracionTitlesOsama[currentTopic] < titlesTotalesOsama[currentTopic]-1) {
    iteracionTitlesOsama[currentTopic]+=1;
  } else {
    iteracionTitlesOsama[currentTopic] = 1;
  }
  println(">> deseo cambiar el book title: "+iteracionTitlesOsama[currentTopic]+" VS total"+titlesTotalesOsama[currentTopic]);
  // We set the new title ||||||||||||||||||||||||||||||||||||||||||
  if ( tipo == "der" ) {
    currentTitleDer = titlesOsama[currentTopic][iteracionTitlesOsama[currentTopic]];
  }
  if ( tipo == "izq" ) {
    currentTitleIzq = titlesOsama[currentTopic][iteracionTitlesOsama[currentTopic]];
  }
}
// WATCH OUT FOR THE PREVIOUS FUNCTION, WE miGHT RUN INTO SOME NULL VALUES!!!! CARFEUL!
// ---------
// We will mix everything
void mixItUp() {

  for (int i = 1; i < totalCols; i++) {
    int inicioRandom = floor(random(1, titlesTotalesOsama[i]));
    iteracionTitlesOsama[i] = inicioRandom;
  }
}
