
// ------------------------------------------------------------
// -------------------- interaction -----------------------------
// ------------------------------------------------------------

// ----------------------------------- Keyboard actions
void keyPressed() {
  // *
  if (key == 's') { // ---------------------- save image
    save( "CAPTURES/TheChipsAreDown_Vocoder"+year()+month()+day()+"_"+hour()+"-"+minute()+"-"+second()+".png");
  }
  if(key == 'b') pobladoresBoston = !pobladoresBoston;
  if(key == 'a') pobladoresOsama = !pobladoresOsama;
  if(key == 'm') pobladores = !pobladores;
  if(key == 'p') speakActivo = !speakActivo;
  if(key == 'z') automatizado = !automatizado; // The speak automatizado
  if(key == 'v') voz = !voz;
  // *
  // * Changing the category
  if(key == '1'){
    automatizado = false;
    changeTopic(1);
  }
  if(key == '2'){
    automatizado = false;
    changeTopic(2);
  }
  // *
  // *
  // *
  // *
  // *
  // *
  // *
  // *
  // *
}



// -------------------------------------------------------------------
// Unconventional mouse INteraction
//

void mouseInteraction() {

  // 1. We recalculate the mouse Position
  float posMouseX = mouseX;//-centroX;
  float posMouseY = mouseY;//-centroY;
  // println(posMouseX);

  // 2. We ask for the distance (our orbit)
  float distanciaMouse = dist(posMouseX, posMouseY, centroX, centroY);
  // println("distancia: "+distanciaMouse);

  // 3. We ask if it is proper to draw a line
  if (distanciaMouse < orbitaMax && distanciaMouse > orbitaMin) {
    // a. ask for a proper position
    int orbitaNuevaPos = floor(map(distanciaMouse, orbitaMin, orbitaMax, 1, cantidad));

    // b. We get the desired orbit
    float orbitaMouse = orbitas[orbitaNuevaPos].getOrbita();

    // c. We draw the orbit
    float grosor = 12;
    strokeWeight(grosor);
    stroke(0, 0, 0, 20);
    strokeCap(SQUARE);
    noFill();
    //ellipse( centroX, centroY, orbitaMouse+(grosor/2), orbitaMouse+(grosor/2));
    ellipse( centroX, centroY, orbitaMouse, orbitaMouse);
  }
}
